{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bam_readgroup_to_json:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/INPUT",
                    "type": "File",
                    "format": "#bam_readgroup_to_json.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "--bam_path"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/MODE",
                    "type": "string",
                    "default": "strict",
                    "inputBinding": {
                        "prefix": "--mode"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bam_readgroup_to_json"
            ],
            "id": "#bam_readgroup_to_json.cwl",
            "outputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/OUTPUT",
                    "format": "#bam_readgroup_to_json.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.json",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.log"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bam_reheader:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bam_reheader.cwl/bam_path",
                    "type": "File",
                    "format": "#bam_reheader.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "--bam_path"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#bam_reheader.cwl/output_bam",
                    "type": "File",
                    "format": "#bam_reheader.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.bam_path.basename)"
                    }
                },
                {
                    "id": "#bam_reheader.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam_path.basename + \".log\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bam_reheader"
            ],
            "id": "#bam_reheader.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/biobambam:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/collate",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "collate=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/exclude",
                    "type": "string",
                    "default": "QCFAIL,SECONDARY,SUPPLEMENTARY",
                    "inputBinding": {
                        "prefix": "exclude=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/filename",
                    "format": "#biobambam2_bamtofastq.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "filename=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/gz",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "gz=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/inputformat",
                    "type": "string",
                    "default": "bam",
                    "inputBinding": {
                        "prefix": "inputformat=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/level",
                    "type": "int",
                    "default": 5,
                    "inputBinding": {
                        "prefix": "level=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "outputdir=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroup",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "outputperreadgroup=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF",
                    "type": "string",
                    "default": "_1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF2",
                    "type": "string",
                    "default": "_2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO",
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO2",
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixS",
                    "type": "string",
                    "default": "_s.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixS=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/tryoq",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "tryoq=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/T",
                    "type": "string",
                    "default": "tempfq",
                    "inputBinding": {
                        "prefix": "T=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_s",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_s.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bamtofastq"
            ],
            "id": "#biobambam2_bamtofastq.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bwa:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bwa_pe.cwl/fastq1",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_2182"
                },
                {
                    "id": "#bwa_pe.cwl/fastq2",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_2182"
                },
                {
                    "id": "#bwa_pe.cwl/fasta",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_1929",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ]
                },
                {
                    "id": "#bwa_pe.cwl/readgroup_json_path",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_3464",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": null
                    }
                },
                {
                    "id": "#bwa_pe.cwl/fastqc_json_path",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_3464",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": null
                    }
                },
                {
                    "id": "#bwa_pe.cwl/thread_count",
                    "type": "int"
                }
            ],
            "outputs": [
                {
                    "id": "#bwa_pe.cwl/OUTPUT",
                    "type": "File",
                    "format": "#bwa_pe.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.readgroup_json_path.basename.slice(0,-4) + \"bam\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  function to_rg() {\n    var readgroup_str = \"@RG\";\n    var readgroup_json = JSON.parse(inputs.readgroup_json_path.contents);\n    var keys = Object.keys(readgroup_json).sort();\n    for (var i = 0; i < keys.length; i++) {\n      var key = keys[i];\n      var value = readgroup_json[key];\n      readgroup_str = readgroup_str + \"\\\\t\" + key + \":\" + value;\n    }\n    return readgroup_str\n  }\n\n  function bwa_aln_33(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq1.path, \">\", \"aln.sai1\", \"&&\",\n    \"bwa\", \"aln\", \"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq2.path, \">\", \"aln.sai2\", \"&&\",\n    \"bwa\", \"sampe\", \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai1\", \"aln.sai2\", inputs.fastq1.path, inputs.fastq2.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_aln_64(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-I\",\"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq1.path, \">\", \"aln.sai1\", \"&&\",\n    \"bwa\", \"aln\", \"-I\", \"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq2.path, \">\", \"aln.sai2\", \"&&\",\n    \"bwa\", \"sampe\", \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai1\", \"aln.sai2\", inputs.fastq1.path, inputs.fastq2.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_mem(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"mem\", \"-t\", inputs.thread_count, \"-T\", \"0\", \"-R\", \"\\\"\" + rg_str + \"\\\"\",\n    inputs.fasta.path, inputs.fastq1.path, inputs.fastq2.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  var MEM_ALN_CUTOFF = 70;\n  var fastqc_json = JSON.parse(inputs.fastqc_json_path.contents);\n  var readlength = fastqc_json[inputs.fastq1.basename][\"Sequence length\"];\n  var encoding = fastqc_json[inputs.fastq1.basename][\"Encoding\"];\n  var rg_str = to_rg();\n\n  var outbam = inputs.readgroup_json_path.basename.slice(0,-4) + \"bam\";\n  \n  if (encoding == \"Illumina 1.3\" || encoding == \"Illumina 1.5\") {\n    return bwa_aln_64(rg_str, outbam)\n  } else if (encoding == \"Sanger / Illumina 1.9\") {\n    if (readlength < MEM_ALN_CUTOFF) {\n      return bwa_aln_33(rg_str, outbam)\n    }\n    else {\n      return bwa_mem(rg_str, outbam)\n    }\n  } else {\n    return\n  }\n\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#bwa_pe.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bwa:1"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bwa_se.cwl/fastq",
                    "type": "File",
                    "format": "#bwa_se.cwl/format_2182"
                },
                {
                    "id": "#bwa_se.cwl/fasta",
                    "type": "File",
                    "format": "#bwa_se.cwl/format_1929",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ]
                },
                {
                    "id": "#bwa_se.cwl/readgroup_json_path",
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": null
                    }
                },
                {
                    "id": "#bwa_se.cwl/fastqc_json_path",
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": null
                    }
                },
                {
                    "id": "#bwa_se.cwl/thread_count",
                    "type": "int"
                }
            ],
            "outputs": [
                {
                    "id": "#bwa_se.cwl/OUTPUT",
                    "type": "File",
                    "format": "#bwa_se.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.readgroup_json_path.basename.slice(0,-4) + \"bam\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  function to_rg() {\n    var readgroup_str = \"@RG\";\n    var readgroup_json = JSON.parse(inputs.readgroup_json_path.contents);\n    var keys = Object.keys(readgroup_json).sort();\n    for (var i = 0; i < keys.length; i++) {\n      var key = keys[i];\n      var value = readgroup_json[key];\n      readgroup_str = readgroup_str + \"\\\\t\" + key + \":\" + value;\n    }\n    return readgroup_str\n  }\n\n  function bwa_aln_33(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq.path, \">\", \"aln.sai\", \"&&\",\n    \"bwa\", \"samse\", \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai\", inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_aln_64(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-I\",\"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq.path, \">\", \"aln.sai\", \"&&\",\n    \"bwa\", \"samse\", \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai\", inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_mem(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"mem\", \"-t\", inputs.thread_count, \"-T\", \"0\", \"-R\", \"\\\"\" + rg_str + \"\\\"\",\n    inputs.fasta.path, inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  var MEM_ALN_CUTOFF = 70;\n  var fastqc_json = JSON.parse(inputs.fastqc_json_path.contents);\n  var readlength = fastqc_json[inputs.fastq.basename][\"Sequence length\"];\n  var encoding = fastqc_json[inputs.fastq.basename][\"Encoding\"];\n  var rg_str = to_rg();\n\n  var outbam = inputs.readgroup_json_path.basename.slice(0,-4) + \"bam\";\n\n  if (encoding == \"Illumina 1.3\" || encoding == \"Illumina 1.5\") {\n    return bwa_aln_64(rg_str, outbam)\n  } else if (encoding == \"Sanger / Illumina 1.9\") {\n    if (readlength < MEM_ALN_CUTOFF) {\n      return bwa_aln_33(rg_str, outbam)\n    }\n    else {\n      return bwa_mem(rg_str, outbam)\n    }\n  } else {\n    return\n  }\n\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#bwa_se.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/curl:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#curl.cwl/output",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--output"
                    }
                },
                {
                    "id": "#curl.cwl/url",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--url"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#curl.cwl/output_file",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    }
                }
            ],
            "baseCommand": [
                "curl"
            ],
            "id": "#curl.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#decider_bwa_expression.cwl/fastq_path",
                    "format": "#decider_bwa_expression.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#decider_bwa_expression.cwl/readgroup_path",
                    "format": "#decider_bwa_expression.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#decider_bwa_expression.cwl/output_readgroup_paths",
                    "format": "#decider_bwa_expression.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "expression": "${\n   function include(arr,obj) {\n     return (arr.indexOf(obj) != -1)\n   }\n\n   function endsWith(str, suffix) {\n     return str.indexOf(suffix, str.length - suffix.length) !== -1;\n   }\n\n   function local_basename(path) {\n     var basename = path.split(/[\\\\/]/).pop();\n     return basename\n   }\n\n   function local_dirname(path) {\n     return path.replace(/\\\\/g,'/').replace(/\\/[^\\/]*$/, '');\n   }\n\n   function get_slice_number(fastq_name) {\n     if (endsWith(fastq_name, '_1.fq.gz')) {\n       return -8\n     }\n     else if (endsWith(fastq_name, '_s.fq.gz')) {\n       return -8\n     }\n     else if (endsWith(fastq_name, '_o1.fq.gz')) {\n       return -9\n     }\n     else if (endsWith(fastq_name, '_o2.fq.gz')) {\n       return -9\n     }\n     else {\n       exit()\n     }\n   }\n   \n   // get predicted readgroup basenames from fastq\n   var readgroup_basename_array = [];\n   for (var i = 0; i < inputs.fastq_path.length; i++) {\n     var fq_path = inputs.fastq_path[i];\n     var fq_name = local_basename(fq_path.location);\n\n     var slice_number = get_slice_number(fq_name);\n     \n     var readgroup_name = fq_name.slice(0,slice_number) + \".json\";\n     readgroup_basename_array.push(readgroup_name);\n   }\n\n   // find which readgroup items are in predicted basenames\n   var readgroup_array = [];\n   for (var i = 0; i < inputs.readgroup_path.length; i++) {\n     var readgroup_path = inputs.readgroup_path[i];\n     var readgroup_basename = local_basename(readgroup_path.location);\n     if (include(readgroup_basename_array, readgroup_basename)) {\n       readgroup_array.push(readgroup_path);\n     }\n   }\n\n   var readgroup_sorted = readgroup_array.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) })\n   return {'output_readgroup_paths': readgroup_sorted}\n }\n",
            "id": "#decider_bwa_expression.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastq_remove_duplicate_qname:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/INPUT",
                    "type": "File",
                    "format": "#fastq_remove_duplicate_qname.cwl/format_2182"
                }
            ],
            "outputs": [
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/OUTPUT",
                    "type": "File",
                    "format": "#fastq_remove_duplicate_qname.cwl/format_2182",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename)"
                    }
                },
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/METRICS",
                    "type": "File",
                    "outputBinding": {
                        "glob": "fastq_dup_rm.log"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  var cmd = [\n  \"zcat\", inputs.INPUT.path, \"|\",\n  \"/usr/local/bin/fastq_remove_duplicate_qname\", \"-\", \"|\",\n  \"gzip\", \"-\", \">\", inputs.INPUT.basename\n  ];\n  return cmd.join(' ')\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#fastq_remove_duplicate_qname.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc.cwl/adapters",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--adapters"
                    }
                },
                {
                    "id": "#fastqc.cwl/casava",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--casava"
                    }
                },
                {
                    "id": "#fastqc.cwl/contaminants",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--contaminants"
                    }
                },
                {
                    "id": "#fastqc.cwl/dir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--dir"
                    }
                },
                {
                    "id": "#fastqc.cwl/extract",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--extract"
                    }
                },
                {
                    "id": "#fastqc.cwl/format",
                    "type": "string",
                    "default": "fastq",
                    "inputBinding": {
                        "prefix": "--format"
                    }
                },
                {
                    "id": "#fastqc.cwl/INPUT",
                    "type": "File",
                    "format": "#fastqc.cwl/format_2182",
                    "inputBinding": {
                        "position": 99
                    }
                },
                {
                    "id": "#fastqc.cwl/kmers",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--kmers"
                    }
                },
                {
                    "id": "#fastqc.cwl/limits",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--limits"
                    }
                },
                {
                    "id": "#fastqc.cwl/nano",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nano"
                    }
                },
                {
                    "id": "#fastqc.cwl/noextract",
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--noextract"
                    }
                },
                {
                    "id": "#fastqc.cwl/nofilter",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nofilter"
                    }
                },
                {
                    "id": "#fastqc.cwl/nogroup",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nogroup"
                    }
                },
                {
                    "id": "#fastqc.cwl/outdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--outdir"
                    }
                },
                {
                    "id": "#fastqc.cwl/quiet",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--quiet"
                    }
                },
                {
                    "id": "#fastqc.cwl/threads",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--threads"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  function endsWith(str, suffix) {\n    return str.indexOf(suffix, str.length - suffix.length) !== -1;\n  }\n\n  var filename = inputs.INPUT.nameroot;\n\n  if ( endsWith(filename, '.fq') ) {\n    var nameroot = filename.slice(0,-3);\n  }\n  else if ( endsWith(nameroot, '.fastq') ) {\n    var nameroot = filename.slice(0,-6);\n  }\n  else {\n    var nameroot = filename;\n  }\n\n  var output = nameroot +\"_fastqc.zip\";\n  return output\n}\n  \n"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/FastQC/fastqc"
            ],
            "id": "#fastqc.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc_to_json:1"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc_basicstatistics_json.cwl/sqlite_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--sqlite_path"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc_basicstatistics_json.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "fastqc.json"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastqc_to_json"
            ],
            "id": "#fastqc_basicstatistics_json.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc_db:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc_db.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--INPUT"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc_db.cwl/LOG",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".log\")"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastqc_db"
            ],
            "id": "#fastqc_db.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/integrity_to_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#integrity_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#integrity_to_sqlite.cwl/ls_l_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--ls_l_path"
                    }
                },
                {
                    "id": "#integrity_to_sqlite.cwl/md5sum_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--md5sum_path"
                    }
                },
                {
                    "id": "#integrity_to_sqlite.cwl/sha256sum_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--sha256sum_path"
                    }
                },
                {
                    "id": "#integrity_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#integrity_to_sqlite.cwl/LOG",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".log\")"
                    }
                },
                {
                    "id": "#integrity_to_sqlite.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/integrity_to_sqlite"
            ],
            "id": "#integrity_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial-20161010"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#ls_l.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#ls_l.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".ls\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".ls\")",
            "baseCommand": [
                "ls",
                "-l"
            ],
            "id": "#ls_l.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial-20161010"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#md5sum.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#md5sum.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".md5\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".md5\")",
            "baseCommand": [
                "md5sum"
            ],
            "id": "#md5sum.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/merge_sqlite:3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#merge_sqlite.cwl/source_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--source_sqlite"
                        }
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#merge_sqlite.cwl/destination_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".log\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/merge_sqlite"
            ],
            "id": "#merge_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectmultiplemetrics.cwl/DB_SNP",
                    "type": "File",
                    "format": "#picard_collectmultiplemetrics.cwl/format_3016",
                    "inputBinding": {
                        "prefix": "DB_SNP=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_collectmultiplemetrics.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/METRIC_ACCUMULATION_LEVEL=",
                    "type": "string",
                    "default": "ALL_READS",
                    "inputBinding": {
                        "prefix": "METRIC_ACCUMULATION_LEVEL=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/REFERENCE_SEQUENCE",
                    "type": "File",
                    "format": "#picard_collectmultiplemetrics.cwl/format_1929",
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/TMP_DIR",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/VALIDATION_STRINGENCY",
                    "default": "STRICT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectmultiplemetrics.cwl/alignment_summary_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".alignment_summary_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/bait_bias_detail_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".bait_bias_detail_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/bait_bias_summary_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".bait_bias_summary_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/base_distribution_by_cycle_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".base_distribution_by_cycle_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/base_distribution_by_cycle_pdf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".base_distribution_by_cycle.pdf\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/gc_bias_detail_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".gc_bias.detail_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/gc_bias_pdf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".gc_bias.pdf\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/gc_bias_summary_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".gc_bias.summary_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/insert_size_histogram_pdf",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".insert_size_histogram.pdf\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/insert_size_metrics",
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".insert_size_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/pre_adapter_detail_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".pre_adapter_detail_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/pre_adapter_summary_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".pre_adapter_summary_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/quality_by_cycle_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".quality_by_cycle_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/quality_by_cycle_pdf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".quality_by_cycle.pdf\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/quality_distribution_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".quality_distribution_metrics\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/quality_distribution_pdf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".quality_distribution.pdf\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics.cwl/quality_yield_metrics",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".quality_yield_metrics\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "PROGRAM=CollectAlignmentSummaryMetrics"
                },
                {
                    "valueFrom": "PROGRAM=CollectBaseDistributionByCycle"
                },
                {
                    "valueFrom": "PROGRAM=CollectGcBiasMetrics"
                },
                {
                    "valueFrom": "PROGRAM=CollectInsertSizeMetrics"
                },
                {
                    "valueFrom": "PROGRAM=CollectQualityYieldMetrics"
                },
                {
                    "valueFrom": "PROGRAM=CollectSequencingArtifactMetrics"
                },
                {
                    "valueFrom": "PROGRAM=MeanQualityByCycle"
                },
                {
                    "valueFrom": "PROGRAM=QualityScoreDistribution"
                },
                {
                    "valueFrom": "$(inputs.INPUT.nameroot)",
                    "prefix": "OUTPUT=",
                    "separate": false
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "CollectMultipleMetrics"
            ],
            "id": "#picard_collectmultiplemetrics.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/fasta",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--fasta"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/vcf",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--vcf"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/alignment_summary_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--alignment_summary_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/bait_bias_detail_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--bait_bias_detail_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/bait_bias_summary_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--bait_bias_summary_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/base_distribution_by_cycle_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--base_distribution_by_cycle_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/gc_bias_detail_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--gc_bias_detail_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/gc_bias_summary_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--gc_bias_summary_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/insert_size_metrics",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--insert_size_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/pre_adapter_detail_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--pre_adapter_detail_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/pre_adapter_summary_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--pre_adapter_summary_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/quality_by_cycle_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--quality_by_cycle_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/quality_distribution_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--quality_distribution_metrics"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/quality_yield_metrics",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--quality_yield_metrics"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_picard_CollectMultipleMetrics.log\")"
                    }
                },
                {
                    "id": "#picard_collectmultiplemetrics_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/picard_metrics_sqlite",
                "--metric_name",
                "CollectMultipleMetrics"
            ],
            "id": "#picard_collectmultiplemetrics_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectoxogmetrics.cwl/DB_SNP",
                    "type": "File",
                    "format": "#picard_collectoxogmetrics.cwl/format_3016",
                    "inputBinding": {
                        "prefix": "DB_SNP=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_collectoxogmetrics.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics.cwl/REFERENCE_SEQUENCE",
                    "type": "File",
                    "format": "#picard_collectoxogmetrics.cwl/format_1929",
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics.cwl/TMP_DIR",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics.cwl/USE_OQ",
                    "type": "string",
                    "default": "true",
                    "inputBinding": {
                        "prefix": "USE_OQ=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics.cwl/VALIDATION_STRINGENCY",
                    "default": "STRICT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectoxogmetrics.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename + \".metrics\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.INPUT.basename + \".metrics\")",
                    "prefix": "OUTPUT=",
                    "separate": false
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "CollectOxoGMetrics"
            ],
            "id": "#picard_collectoxogmetrics.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/fasta",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--fasta"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/vcf",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--vcf"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_picard_CollectOxoGMetrics.log\")"
                    }
                },
                {
                    "id": "#picard_collectoxogmetrics_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/picard_metrics_sqlite",
                "--metric_name",
                "CollectOxoGMetrics"
            ],
            "id": "#picard_collectoxogmetrics_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectwgsmetrics.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_collectwgsmetrics.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics.cwl/REFERENCE_SEQUENCE",
                    "type": "File",
                    "format": "#picard_collectwgsmetrics.cwl/format_1929",
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics.cwl/VALIDATION_STRINGENCY",
                    "default": "STRICT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectwgsmetrics.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".metrics\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.INPUT.nameroot + \".metrics\")",
                    "prefix": "OUTPUT=",
                    "separate": false
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "CollectWgsMetrics"
            ],
            "id": "#picard_collectwgsmetrics.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/fasta",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--fasta"
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_picard_CollectWgsMetrics.log\")"
                    }
                },
                {
                    "id": "#picard_collectwgsmetrics_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/picard_metrics_sqlite",
                "--metric_name",
                "CollectWgsMetrics"
            ],
            "id": "#picard_collectwgsmetrics_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_markduplicates.cwl/CREATE_INDEX",
                    "type": "string",
                    "default": "true",
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_markduplicates.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_markduplicates.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_markduplicates.cwl/TMP_DIR",
                    "default": ".",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_markduplicates.cwl/VALIDATION_STRINGENCY",
                    "default": "STRICT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_markduplicates.cwl/OUTPUT",
                    "type": "File",
                    "format": "#picard_markduplicates.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename)"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ]
                },
                {
                    "id": "#picard_markduplicates.cwl/METRICS",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename + \".metrics\")"
                    }
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "MarkDuplicates"
            ],
            "id": "#picard_markduplicates.cwl",
            "arguments": [
                {
                    "valueFrom": "$(inputs.INPUT.basename)",
                    "prefix": "OUTPUT=",
                    "separate": false
                },
                {
                    "valueFrom": "$(inputs.INPUT.basename + \".metrics\")",
                    "prefix": "METRICS_FILE=",
                    "separate": false
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_picard_MarkDuplicates.log\")"
                    }
                },
                {
                    "id": "#picard_markduplicates_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/picard_metrics_sqlite",
                "--metric_name",
                "MarkDuplicates"
            ],
            "id": "#picard_markduplicates_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_mergesamfiles.cwl/ASSUME_SORTED",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "ASSUME_SORTED=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/CREATE_INDEX",
                    "type": "string",
                    "default": "true",
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/INPUT",
                    "format": "#picard_mergesamfiles.cwl/format_2572",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/INTERVALS",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "INTERVALS=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/MERGE_SEQUENCE_DICTIONARIES",
                    "type": "string",
                    "default": "false",
                    "inputBinding": {
                        "prefix": "MERGE_SEQUENCE_DICTIONARIES=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/OUTPUT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "OUTPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/SORT_ORDER",
                    "type": "string",
                    "default": "coordinate",
                    "inputBinding": {
                        "prefix": "SORT_ORDER=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/TMP_DIR",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/USE_THREADING",
                    "type": "string",
                    "default": "true",
                    "inputBinding": {
                        "prefix": "USE_THREADING=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_mergesamfiles.cwl/VALIDATION_STRINGENCY",
                    "type": "string",
                    "default": "STRICT",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_mergesamfiles.cwl/MERGED_OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.OUTPUT)"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  if (inputs.INPUT.length == 0) {\n    var cmd = ['/usr/bin/touch', inputs.OUTPUT];\n    return cmd\n  }\n  else {\n    var cmd = [\"java\", \"-jar\", \"/usr/local/bin/picard.jar\", \"MergeSamFiles\"];\n    var use_input = [];\n    for (var i = 0; i < inputs.INPUT.length; i++) {\n      var filesize = inputs.INPUT[i].size;\n      if (filesize > 0) {\n        use_input.push(\"INPUT=\" + inputs.INPUT[i].path);\n      }\n    }\n\n    var run_cmd = cmd.concat(use_input);\n    return run_cmd\n  }\n\n}\n"
                }
            ],
            "baseCommand": [],
            "id": "#picard_mergesamfiles.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_sortsam.cwl/CREATE_INDEX",
                    "type": "string",
                    "default": "true",
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_sortsam.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_sortsam.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_sortsam.cwl/OUTPUT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "OUTPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_sortsam.cwl/SORT_ORDER",
                    "type": "string",
                    "default": "coordinate",
                    "inputBinding": {
                        "prefix": "SORT_ORDER=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_sortsam.cwl/TMP_DIR",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_sortsam.cwl/VALIDATION_STRINGENCY",
                    "type": "string",
                    "default": "STRICT",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_sortsam.cwl/SORTED_OUTPUT",
                    "type": "File",
                    "format": "#picard_sortsam.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.OUTPUT)"
                    }
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "SortSam"
            ],
            "id": "#picard_sortsam.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_validatesamfile.cwl/INPUT",
                    "type": "File",
                    "format": "#picard_validatesamfile.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "INPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_validatesamfile.cwl/MAX_OUTPUT",
                    "type": "int",
                    "default": 2147483647,
                    "inputBinding": {
                        "prefix": "MAX_OUTPUT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_validatesamfile.cwl/MODE",
                    "type": "string",
                    "default": "VERBOSE",
                    "inputBinding": {
                        "prefix": "MODE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_validatesamfile.cwl/TMP_DIR",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_validatesamfile.cwl/VALIDATION_STRINGENCY",
                    "default": "STRICT",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_validatesamfile.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename + \".metrics\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.INPUT.basename + \".metrics\")",
                    "prefix": "OUTPUT=",
                    "separate": false
                }
            ],
            "successCodes": [
                0,
                1
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "ValidateSamFile"
            ],
            "id": "#picard_validatesamfile.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_picard_ValidateSamFile.log\")"
                    }
                },
                {
                    "id": "#picard_validatesamfile_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "format": "#picard_validatesamfile_to_sqlite.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/picard_metrics_sqlite",
                "--metric_name",
                "ValidateSamFile"
            ],
            "id": "#picard_validatesamfile_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/readgroup_json_db:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#readgroup_json_db.cwl/json_path",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3464",
                    "inputBinding": {
                        "prefix": "--json_path"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#readgroup_json_db.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid +\".log\")"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/output_sqlite",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/readgroup_json_db"
            ],
            "id": "#readgroup_json_db.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.fasta.basename)",
                            "entry": "$(inputs.fasta)"
                        },
                        {
                            "entryname": "$(inputs.fasta_amb.basename)",
                            "entry": "$(inputs.fasta_amb)"
                        },
                        {
                            "entryname": "$(inputs.fasta_ann.basename)",
                            "entry": "$(inputs.fasta_ann)"
                        },
                        {
                            "entryname": "$(inputs.fasta_bwt.basename)",
                            "entry": "$(inputs.fasta_bwt)"
                        },
                        {
                            "entryname": "$(inputs.fasta_pac.basename)",
                            "entry": "$(inputs.fasta_pac)"
                        },
                        {
                            "entryname": "$(inputs.fasta_sa.basename)",
                            "entry": "$(inputs.fasta_sa)"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta",
                    "type": "File",
                    "format": "#root_fasta_dnaseq.cwl/format_1929"
                },
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta_amb",
                    "type": "File"
                },
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta_ann",
                    "type": "File"
                },
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta_bwt",
                    "type": "File"
                },
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta_pac",
                    "type": "File"
                },
                {
                    "id": "#root_fasta_dnaseq.cwl/fasta_sa",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#root_fasta_dnaseq.cwl/output",
                    "type": "File",
                    "format": "#root_fasta_dnaseq.cwl/format_1929",
                    "outputBinding": {
                        "glob": "$(inputs.fasta.basename)"
                    },
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ]
                }
            ],
            "baseCommand": "true",
            "id": "#root_fasta_dnaseq.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_bamtobam.cwl/INPUT",
                    "format": "#samtools_bamtobam.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_bamtobam.cwl/OUTPUT",
                    "format": "#samtools_bamtobam.cwl/format_2572",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename)"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.basename)",
            "baseCommand": [
                "/usr/local/bin/samtools",
                "view",
                "-Shb"
            ],
            "id": "#samtools_bamtobam.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_flagstat.cwl/INPUT",
                    "type": "File",
                    "format": "#samtools_flagstat.cwl/format_2572",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_flagstat.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".flagstat\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".flagstat\")",
            "baseCommand": [
                "/usr/local/bin/samtools",
                "flagstat"
            ],
            "id": "#samtools_flagstat.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_samtools_flagstat.log\")"
                    }
                },
                {
                    "id": "#samtools_flagstat_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/samtools_metrics_sqlite",
                "--metric_name",
                "flagstat"
            ],
            "id": "#samtools_flagstat_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_idxstats.cwl/INPUT",
                    "type": "File",
                    "format": "#samtools_idxstats.cwl/format_2572",
                    "inputBinding": {
                        "position": 0
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ]
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_idxstats.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".idxstats\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".idxstats\")",
            "baseCommand": [
                "/usr/local/bin/samtools",
                "idxstats"
            ],
            "id": "#samtools_idxstats.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_samtools_idxstats.log\")"
                    }
                },
                {
                    "id": "#samtools_idxstats_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/samtools_metrics_sqlite",
                "--metric_name",
                "idxstats"
            ],
            "id": "#samtools_idxstats_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_stats.cwl/INPUT",
                    "type": "File",
                    "format": "#samtools_stats.cwl/format_2572",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_stats.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".stats\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".stats\")",
            "baseCommand": [
                "/usr/local/bin/samtools",
                "stats"
            ],
            "id": "#samtools_stats.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/samtools_metrics_sqlite:1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#samtools_stats_to_sqlite.cwl/bam",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--bam"
                    }
                },
                {
                    "id": "#samtools_stats_to_sqlite.cwl/input_state",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--input_state"
                    }
                },
                {
                    "id": "#samtools_stats_to_sqlite.cwl/metric_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--metric_path"
                    }
                },
                {
                    "id": "#samtools_stats_to_sqlite.cwl/uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#samtools_stats_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid+\"_samtools_stats.log\")"
                    }
                },
                {
                    "id": "#samtools_stats_to_sqlite.cwl/sqlite",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/samtools_metrics_sqlite",
                "--metric_name",
                "stats"
            ],
            "id": "#samtools_stats_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial-20161010"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#sha256sum.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sha256sum.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".sha256\")"
                    }
                }
            ],
            "stdout": "$(inputs.INPUT.nameroot + \".sha256\")",
            "baseCommand": [
                "sha256sum"
            ],
            "id": "#sha256sum.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#sort_scatter_expression.cwl/INPUT",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sort_scatter_expression.cwl/OUTPUT",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "expression": "${\n  var output = inputs.INPUT.sort(function(a,b) { return a.basename > b.basename ? 1 : (a.basename < b.basename ? -1 : 0) });\n  return {'OUTPUT': output}\n}\n",
            "id": "#sort_scatter_expression.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial-20161010"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#untar_fasta.cwl/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#untar_fasta.cwl/fasta",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.fa"
                    }
                }
            ],
            "baseCommand": [
                "tar",
                "xf"
            ],
            "id": "#untar_fasta.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial-20161010"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#untar_fastabwa.cwl/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#untar_fastabwa.cwl/fasta_amb",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.amb"
                    }
                },
                {
                    "id": "#untar_fastabwa.cwl/fasta_ann",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.ann"
                    }
                },
                {
                    "id": "#untar_fastabwa.cwl/fasta_bwt",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bwt"
                    }
                },
                {
                    "id": "#untar_fastabwa.cwl/fasta_pac",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pac"
                    }
                },
                {
                    "id": "#untar_fastabwa.cwl/fasta_sa",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.sa"
                    }
                }
            ],
            "baseCommand": [
                "tar",
                "xf"
            ],
            "id": "#untar_fastabwa.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/bam_url",
                    "type": "string"
                },
                {
                    "id": "#main/bam_name",
                    "type": "string"
                },
                {
                    "id": "#main/dbsnp_url",
                    "type": "string"
                },
                {
                    "id": "#main/dbsnp_name",
                    "type": "string"
                },
                {
                    "id": "#main/fasta_url",
                    "type": "string"
                },
                {
                    "id": "#main/fasta_name",
                    "type": "string"
                },
                {
                    "id": "#main/fasta_bwa_url",
                    "type": "string"
                },
                {
                    "id": "#main/fasta_bwa_name",
                    "type": "string"
                },
                {
                    "id": "#main/thread_count",
                    "type": "int"
                },
                {
                    "id": "#main/uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#main/harmonized_bam",
                    "type": "File",
                    "outputSource": "#main/transform/picard_markduplicates_output"
                },
                {
                    "id": "#main/sqlite",
                    "type": "File",
                    "outputSource": "#main/transform/merge_all_sqlite_destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#main/extract_curl_bam",
                    "run": "#curl.cwl",
                    "in": [
                        {
                            "id": "#main/extract_curl_bam/url",
                            "source": "#main/bam_url"
                        },
                        {
                            "id": "#main/extract_curl_bam/output",
                            "source": "#main/bam_name"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_curl_bam/output_file"
                        }
                    ]
                },
                {
                    "id": "#main/extract_curl_dbsnp",
                    "run": "#curl.cwl",
                    "in": [
                        {
                            "id": "#main/extract_curl_dbsnp/url",
                            "source": "#main/dbsnp_url"
                        },
                        {
                            "id": "#main/extract_curl_dbsnp/output",
                            "source": "#main/dbsnp_name"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_curl_dbsnp/output_file"
                        }
                    ]
                },
                {
                    "id": "#main/extract_curl_fasta",
                    "run": "#curl.cwl",
                    "in": [
                        {
                            "id": "#main/extract_curl_fasta/url",
                            "source": "#main/fasta_url"
                        },
                        {
                            "id": "#main/extract_curl_fasta/output",
                            "source": "#main/fasta_name"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_curl_fasta/output_file"
                        }
                    ]
                },
                {
                    "id": "#main/extract_curl_fastabwa",
                    "run": "#curl.cwl",
                    "in": [
                        {
                            "id": "#main/extract_curl_fastabwa/url",
                            "source": "#main/fasta_bwa_url"
                        },
                        {
                            "id": "#main/extract_curl_fastabwa/output",
                            "source": "#main/fasta_bwa_name"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_curl_fastabwa/output_file"
                        }
                    ]
                },
                {
                    "id": "#main/extract_untar_fastabwa",
                    "run": "#untar_fastabwa.cwl",
                    "in": [
                        {
                            "id": "#main/extract_untar_fastabwa/input",
                            "source": "#main/extract_curl_fastabwa/output_file"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_untar_fastabwa/fasta_amb"
                        },
                        {
                            "id": "#main/extract_untar_fastabwa/fasta_ann"
                        },
                        {
                            "id": "#main/extract_untar_fastabwa/fasta_bwt"
                        },
                        {
                            "id": "#main/extract_untar_fastabwa/fasta_pac"
                        },
                        {
                            "id": "#main/extract_untar_fastabwa/fasta_sa"
                        }
                    ]
                },
                {
                    "id": "#main/extract_untar_fasta",
                    "run": "#untar_fasta.cwl",
                    "in": [
                        {
                            "id": "#main/extract_untar_fasta/input",
                            "source": "#main/extract_curl_fasta/output_file"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_untar_fasta/fasta"
                        }
                    ]
                },
                {
                    "id": "#main/root_fasta_files",
                    "run": "#root_fasta_dnaseq.cwl",
                    "in": [
                        {
                            "id": "#main/root_fasta_files/fasta",
                            "source": "#main/extract_untar_fasta/fasta"
                        },
                        {
                            "id": "#main/root_fasta_files/fasta_amb",
                            "source": "#main/extract_untar_fastabwa/fasta_amb"
                        },
                        {
                            "id": "#main/root_fasta_files/fasta_ann",
                            "source": "#main/extract_untar_fastabwa/fasta_ann"
                        },
                        {
                            "id": "#main/root_fasta_files/fasta_bwt",
                            "source": "#main/extract_untar_fastabwa/fasta_bwt"
                        },
                        {
                            "id": "#main/root_fasta_files/fasta_pac",
                            "source": "#main/extract_untar_fastabwa/fasta_pac"
                        },
                        {
                            "id": "#main/root_fasta_files/fasta_sa",
                            "source": "#main/extract_untar_fastabwa/fasta_sa"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/root_fasta_files/output"
                        }
                    ]
                },
                {
                    "id": "#main/transform",
                    "run": "#transform.cwl",
                    "in": [
                        {
                            "id": "#main/transform/bam_path",
                            "source": "#main/extract_curl_bam/output_file"
                        },
                        {
                            "id": "#main/transform/db_snp_path",
                            "source": "#main/extract_curl_dbsnp/output_file"
                        },
                        {
                            "id": "#main/transform/reference_fasta_path",
                            "source": "#main/root_fasta_files/output"
                        },
                        {
                            "id": "#main/transform/thread_count",
                            "source": "#main/thread_count"
                        },
                        {
                            "id": "#main/transform/uuid",
                            "source": "#main/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/transform/picard_markduplicates_output"
                        },
                        {
                            "id": "#main/transform/merge_all_sqlite_destination_sqlite"
                        }
                    ]
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#integrity.cwl/bai_path",
                    "type": "File"
                },
                {
                    "id": "#integrity.cwl/bam_path",
                    "type": "File"
                },
                {
                    "id": "#integrity.cwl/input_state",
                    "type": "string"
                },
                {
                    "id": "#integrity.cwl/uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#integrity.cwl/merge_sqlite_destination_sqlite",
                    "type": "File",
                    "outputSource": "#integrity.cwl/merge_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#integrity.cwl/bai_ls_l",
                    "run": "#ls_l.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bai_ls_l/INPUT",
                            "source": "#integrity.cwl/bai_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bai_ls_l/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bai_md5sum",
                    "run": "#md5sum.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bai_md5sum/INPUT",
                            "source": "#integrity.cwl/bai_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bai_md5sum/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bai_sha256",
                    "run": "#sha256sum.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bai_sha256/INPUT",
                            "source": "#integrity.cwl/bai_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bai_sha256/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bam_ls_l",
                    "run": "#ls_l.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bam_ls_l/INPUT",
                            "source": "#integrity.cwl/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bam_ls_l/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bam_md5sum",
                    "run": "#md5sum.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bam_md5sum/INPUT",
                            "source": "#integrity.cwl/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bam_md5sum/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bam_sha256",
                    "run": "#sha256sum.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bam_sha256/INPUT",
                            "source": "#integrity.cwl/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bam_sha256/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bai_integrity_to_db",
                    "run": "#integrity_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/input_state",
                            "source": "#integrity.cwl/input_state"
                        },
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/ls_l_path",
                            "source": "#integrity.cwl/bai_ls_l/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/md5sum_path",
                            "source": "#integrity.cwl/bai_md5sum/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/sha256sum_path",
                            "source": "#integrity.cwl/bai_sha256/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/uuid",
                            "source": "#integrity.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bai_integrity_to_db/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/bam_integrity_to_db",
                    "run": "#integrity_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/input_state",
                            "source": "#integrity.cwl/input_state"
                        },
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/ls_l_path",
                            "source": "#integrity.cwl/bam_ls_l/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/md5sum_path",
                            "source": "#integrity.cwl/bam_md5sum/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/sha256sum_path",
                            "source": "#integrity.cwl/bam_sha256/OUTPUT"
                        },
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/uuid",
                            "source": "#integrity.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/bam_integrity_to_db/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#integrity.cwl/merge_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#integrity.cwl/merge_sqlite/source_sqlite",
                            "source": [
                                "#integrity.cwl/bai_integrity_to_db/OUTPUT",
                                "#integrity.cwl/bam_integrity_to_db/OUTPUT"
                            ]
                        },
                        {
                            "id": "#integrity.cwl/merge_sqlite/uuid",
                            "source": "#integrity.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#integrity.cwl/merge_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#integrity.cwl/merge_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#integrity.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#metrics.cwl/bam",
                    "type": "File"
                },
                {
                    "id": "#metrics.cwl/db_snp_vcf",
                    "type": "File"
                },
                {
                    "id": "#metrics.cwl/fasta",
                    "type": "File"
                },
                {
                    "id": "#metrics.cwl/input_state",
                    "type": "string"
                },
                {
                    "id": "#metrics.cwl/parent_bam",
                    "type": "string"
                },
                {
                    "id": "#metrics.cwl/thread_count",
                    "type": "int"
                },
                {
                    "id": "#metrics.cwl/uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#metrics.cwl/merge_sqlite_destination_sqlite",
                    "type": "File",
                    "outputSource": "#metrics.cwl/merge_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#metrics.cwl/picard_collectmultiplemetrics",
                    "run": "#picard_collectmultiplemetrics.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/DB_SNP",
                            "source": "#metrics.cwl/db_snp_vcf"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/INPUT",
                            "source": "#metrics.cwl/bam"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/REFERENCE_SEQUENCE",
                            "source": "#metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/alignment_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/bait_bias_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/bait_bias_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/base_distribution_by_cycle_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/gc_bias_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/gc_bias_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/insert_size_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/pre_adapter_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/pre_adapter_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/quality_by_cycle_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/quality_distribution_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics/quality_yield_metrics"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite",
                    "run": "#picard_collectmultiplemetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/fasta",
                            "source": "#metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/vcf",
                            "source": "#metrics.cwl/db_snp_vcf",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/alignment_summary_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/alignment_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bait_bias_detail_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/bait_bias_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bait_bias_summary_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/bait_bias_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/base_distribution_by_cycle_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/base_distribution_by_cycle_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/gc_bias_detail_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/gc_bias_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/gc_bias_summary_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/gc_bias_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/insert_size_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/insert_size_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/pre_adapter_detail_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/pre_adapter_detail_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/pre_adapter_summary_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/pre_adapter_summary_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_by_cycle_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/quality_by_cycle_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_distribution_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/quality_distribution_metrics"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_yield_metrics",
                            "source": "#metrics.cwl/picard_collectmultiplemetrics/quality_yield_metrics"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/log"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/picard_collectoxogmetrics",
                    "run": "#picard_collectoxogmetrics.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics/DB_SNP",
                            "source": "#metrics.cwl/db_snp_vcf"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics/INPUT",
                            "source": "#metrics.cwl/bam"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics/REFERENCE_SEQUENCE",
                            "source": "#metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite",
                    "run": "#picard_collectoxogmetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/fasta",
                            "source": "#metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/metric_path",
                            "source": "#metrics.cwl/picard_collectoxogmetrics/OUTPUT"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/vcf",
                            "source": "#metrics.cwl/db_snp_vcf",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/log"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/picard_collectwgsmetrics",
                    "run": "#picard_collectwgsmetrics.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics/INPUT",
                            "source": "#metrics.cwl/bam"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics/REFERENCE_SEQUENCE",
                            "source": "#metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite",
                    "run": "#picard_collectwgsmetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/fasta",
                            "source": "#metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/metric_path",
                            "source": "#metrics.cwl/picard_collectwgsmetrics/OUTPUT"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/log"
                        },
                        {
                            "id": "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_flagstat",
                    "run": "#samtools_flagstat.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_flagstat/INPUT",
                            "source": "#metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_flagstat/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_flagstat_to_sqlite",
                    "run": "#samtools_flagstat_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_flagstat_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/samtools_flagstat_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/samtools_flagstat_to_sqlite/metric_path",
                            "source": "#metrics.cwl/samtools_flagstat/OUTPUT"
                        },
                        {
                            "id": "#metrics.cwl/samtools_flagstat_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_flagstat_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_idxstats",
                    "run": "#samtools_idxstats.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_idxstats/INPUT",
                            "source": "#metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_idxstats/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_idxstats_to_sqlite",
                    "run": "#samtools_idxstats_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_idxstats_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/samtools_idxstats_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/samtools_idxstats_to_sqlite/metric_path",
                            "source": "#metrics.cwl/samtools_idxstats/OUTPUT"
                        },
                        {
                            "id": "#metrics.cwl/samtools_idxstats_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_idxstats_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_stats",
                    "run": "#samtools_stats.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_stats/INPUT",
                            "source": "#metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_stats/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/samtools_stats_to_sqlite",
                    "run": "#samtools_stats_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/samtools_stats_to_sqlite/bam",
                            "source": "#metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#metrics.cwl/samtools_stats_to_sqlite/input_state",
                            "source": "#metrics.cwl/input_state"
                        },
                        {
                            "id": "#metrics.cwl/samtools_stats_to_sqlite/metric_path",
                            "source": "#metrics.cwl/samtools_stats/OUTPUT"
                        },
                        {
                            "id": "#metrics.cwl/samtools_stats_to_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/samtools_stats_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#metrics.cwl/merge_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#metrics.cwl/merge_sqlite/source_sqlite",
                            "source": [
                                "#metrics.cwl/picard_collectmultiplemetrics_to_sqlite/sqlite",
                                "#metrics.cwl/picard_collectoxogmetrics_to_sqlite/sqlite",
                                "#metrics.cwl/picard_collectwgsmetrics_to_sqlite/sqlite",
                                "#metrics.cwl/samtools_flagstat_to_sqlite/sqlite",
                                "#metrics.cwl/samtools_idxstats_to_sqlite/sqlite",
                                "#metrics.cwl/samtools_stats_to_sqlite/sqlite"
                            ]
                        },
                        {
                            "id": "#metrics.cwl/merge_sqlite/uuid",
                            "source": "#metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#metrics.cwl/merge_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#metrics.cwl/merge_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#metrics.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#mixed_library_metrics.cwl/bam",
                    "type": "File"
                },
                {
                    "id": "#mixed_library_metrics.cwl/db_snp_vcf",
                    "type": "File"
                },
                {
                    "id": "#mixed_library_metrics.cwl/fasta",
                    "type": "File"
                },
                {
                    "id": "#mixed_library_metrics.cwl/input_state",
                    "type": "string"
                },
                {
                    "id": "#mixed_library_metrics.cwl/thread_count",
                    "type": "int"
                },
                {
                    "id": "#mixed_library_metrics.cwl/uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#mixed_library_metrics.cwl/merge_sqlite_destination_sqlite",
                    "type": "File",
                    "outputSource": "#mixed_library_metrics.cwl/merge_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics",
                    "run": "#picard_collectmultiplemetrics.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/DB_SNP",
                            "source": "#mixed_library_metrics.cwl/db_snp_vcf"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/REFERENCE_SEQUENCE",
                            "source": "#mixed_library_metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/alignment_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/bait_bias_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/bait_bias_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/base_distribution_by_cycle_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/gc_bias_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/gc_bias_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/insert_size_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/pre_adapter_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/pre_adapter_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_by_cycle_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_distribution_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_yield_metrics"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite",
                    "run": "#picard_collectmultiplemetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/fasta",
                            "source": "#mixed_library_metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/vcf",
                            "source": "#mixed_library_metrics.cwl/db_snp_vcf",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/alignment_summary_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/alignment_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bait_bias_detail_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/bait_bias_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/bait_bias_summary_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/bait_bias_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/base_distribution_by_cycle_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/base_distribution_by_cycle_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/gc_bias_detail_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/gc_bias_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/gc_bias_summary_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/gc_bias_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/insert_size_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/insert_size_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/pre_adapter_detail_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/pre_adapter_detail_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/pre_adapter_summary_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/pre_adapter_summary_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_by_cycle_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_by_cycle_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_distribution_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_distribution_metrics"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/quality_yield_metrics",
                            "source": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics/quality_yield_metrics"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/log"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics",
                    "run": "#picard_collectoxogmetrics.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics/DB_SNP",
                            "source": "#mixed_library_metrics.cwl/db_snp_vcf"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics/REFERENCE_SEQUENCE",
                            "source": "#mixed_library_metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite",
                    "run": "#picard_collectoxogmetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/fasta",
                            "source": "#mixed_library_metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/metric_path",
                            "source": "#mixed_library_metrics.cwl/picard_collectoxogmetrics/OUTPUT"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/vcf",
                            "source": "#mixed_library_metrics.cwl/db_snp_vcf",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/log"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics",
                    "run": "#picard_collectwgsmetrics.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics/REFERENCE_SEQUENCE",
                            "source": "#mixed_library_metrics.cwl/fasta"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite",
                    "run": "#picard_collectwgsmetrics_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/fasta",
                            "source": "#mixed_library_metrics.cwl/fasta",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/metric_path",
                            "source": "#mixed_library_metrics.cwl/picard_collectwgsmetrics/OUTPUT"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/log"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_flagstat",
                    "run": "#samtools_flagstat.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite",
                    "run": "#samtools_flagstat_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/metric_path",
                            "source": "#mixed_library_metrics.cwl/samtools_flagstat/OUTPUT"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_idxstats",
                    "run": "#samtools_idxstats.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite",
                    "run": "#samtools_idxstats_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/metric_path",
                            "source": "#mixed_library_metrics.cwl/samtools_idxstats/OUTPUT"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_stats",
                    "run": "#samtools_stats.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats/INPUT",
                            "source": "#mixed_library_metrics.cwl/bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite",
                    "run": "#samtools_stats_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/bam",
                            "source": "#mixed_library_metrics.cwl/bam",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/input_state",
                            "source": "#mixed_library_metrics.cwl/input_state"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/metric_path",
                            "source": "#mixed_library_metrics.cwl/samtools_stats/OUTPUT"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#mixed_library_metrics.cwl/merge_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#mixed_library_metrics.cwl/merge_sqlite/source_sqlite",
                            "source": [
                                "#mixed_library_metrics.cwl/picard_collectmultiplemetrics_to_sqlite/sqlite",
                                "#mixed_library_metrics.cwl/picard_collectoxogmetrics_to_sqlite/sqlite",
                                "#mixed_library_metrics.cwl/picard_collectwgsmetrics_to_sqlite/sqlite",
                                "#mixed_library_metrics.cwl/samtools_flagstat_to_sqlite/sqlite",
                                "#mixed_library_metrics.cwl/samtools_idxstats_to_sqlite/sqlite",
                                "#mixed_library_metrics.cwl/samtools_stats_to_sqlite/sqlite"
                            ]
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/merge_sqlite/uuid",
                            "source": "#mixed_library_metrics.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#mixed_library_metrics.cwl/merge_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#mixed_library_metrics.cwl/merge_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#mixed_library_metrics.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#transform.cwl/bam_path",
                    "type": "File"
                },
                {
                    "id": "#transform.cwl/db_snp_path",
                    "type": "File"
                },
                {
                    "id": "#transform.cwl/reference_fasta_path",
                    "type": "File"
                },
                {
                    "id": "#transform.cwl/thread_count",
                    "type": "int"
                },
                {
                    "id": "#transform.cwl/uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#transform.cwl/picard_markduplicates_output",
                    "type": "File",
                    "outputSource": "#transform.cwl/picard_markduplicates/OUTPUT"
                },
                {
                    "id": "#transform.cwl/merge_all_sqlite_destination_sqlite",
                    "type": "File",
                    "outputSource": "#transform.cwl/merge_all_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#transform.cwl/samtools_bamtobam",
                    "run": "#samtools_bamtobam.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/samtools_bamtobam/INPUT",
                            "source": "#transform.cwl/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/samtools_bamtobam/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_validatesamfile_original",
                    "run": "#picard_validatesamfile.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original/INPUT",
                            "source": "#transform.cwl/samtools_bamtobam/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original/VALIDATION_STRINGENCY",
                            "valueFrom": "LENIENT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite",
                    "run": "#picard_validatesamfile_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite/bam",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite/input_state",
                            "valueFrom": "original"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite/metric_path",
                            "source": "#transform.cwl/picard_validatesamfile_original/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_original_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/biobambam_bamtofastq",
                    "run": "#biobambam2_bamtofastq.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/filename",
                            "source": "#transform.cwl/samtools_bamtobam/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#transform.cwl/biobambam_bamtofastq/output_fastq_s"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/remove_duplicate_fastq1",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#transform.cwl/remove_duplicate_fastq1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq1/INPUT",
                            "source": "#transform.cwl/biobambam_bamtofastq/output_fastq1"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/remove_duplicate_fastq2",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#transform.cwl/remove_duplicate_fastq2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq2/INPUT",
                            "source": "#transform.cwl/biobambam_bamtofastq/output_fastq2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/remove_duplicate_fastq_o1",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#transform.cwl/remove_duplicate_fastq_o1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_o1/INPUT",
                            "source": "#transform.cwl/biobambam_bamtofastq/output_fastq_o1"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/remove_duplicate_fastq_o2",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#transform.cwl/remove_duplicate_fastq_o2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_o2/INPUT",
                            "source": "#transform.cwl/biobambam_bamtofastq/output_fastq_o2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/remove_duplicate_fastq_s",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#transform.cwl/remove_duplicate_fastq_s/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_s/INPUT",
                            "source": "#transform.cwl/biobambam_bamtofastq/output_fastq_s"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/remove_duplicate_fastq_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/sort_scattered_fastq1",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq1/INPUT",
                            "source": "#transform.cwl/remove_duplicate_fastq1/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/sort_scattered_fastq2",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq2/INPUT",
                            "source": "#transform.cwl/remove_duplicate_fastq2/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/sort_scattered_fastq_o1",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_o1/INPUT",
                            "source": "#transform.cwl/remove_duplicate_fastq_o1/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/sort_scattered_fastq_o2",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_o2/INPUT",
                            "source": "#transform.cwl/remove_duplicate_fastq_o2/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/sort_scattered_fastq_s",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_s/INPUT",
                            "source": "#transform.cwl/remove_duplicate_fastq_s/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/sort_scattered_fastq_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bam_readgroup_to_json",
                    "run": "#bam_readgroup_to_json.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/bam_readgroup_to_json/INPUT",
                            "source": "#transform.cwl/samtools_bamtobam/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bam_readgroup_to_json/MODE",
                            "valueFrom": "lenient"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/readgroup_json_db",
                    "run": "#readgroup_json_db.cwl",
                    "scatter": "#transform.cwl/readgroup_json_db/json_path",
                    "in": [
                        {
                            "id": "#transform.cwl/readgroup_json_db/json_path",
                            "source": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/readgroup_json_db/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/readgroup_json_db/log"
                        },
                        {
                            "id": "#transform.cwl/readgroup_json_db/output_sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_readgroup_json_db",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_readgroup_json_db/source_sqlite",
                            "source": "#transform.cwl/readgroup_json_db/output_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_readgroup_json_db/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_readgroup_json_db/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_readgroup_json_db/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc1",
                    "run": "#fastqc.cwl",
                    "scatter": "#transform.cwl/fastqc1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc1/INPUT",
                            "source": "#transform.cwl/sort_scattered_fastq1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc1/threads",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc2",
                    "run": "#fastqc.cwl",
                    "scatter": "#transform.cwl/fastqc2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc2/INPUT",
                            "source": "#transform.cwl/sort_scattered_fastq2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc2/threads",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_s",
                    "run": "#fastqc.cwl",
                    "scatter": "#transform.cwl/fastqc_s/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_s/INPUT",
                            "source": "#transform.cwl/sort_scattered_fastq_s/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_s/threads",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_o1",
                    "run": "#fastqc.cwl",
                    "scatter": "#transform.cwl/fastqc_o1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_o1/INPUT",
                            "source": "#transform.cwl/sort_scattered_fastq_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_o1/threads",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_o2",
                    "run": "#fastqc.cwl",
                    "scatter": "#transform.cwl/fastqc_o2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_o2/INPUT",
                            "source": "#transform.cwl/sort_scattered_fastq_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_o2/threads",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_db1",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#transform.cwl/fastqc_db1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_db1/INPUT",
                            "source": "#transform.cwl/fastqc1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db1/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_db1/LOG"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_db2",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#transform.cwl/fastqc_db2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_db2/INPUT",
                            "source": "#transform.cwl/fastqc2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db2/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_db2/LOG"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_db_s",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#transform.cwl/fastqc_db_s/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_db_s/INPUT",
                            "source": "#transform.cwl/fastqc_s/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_s/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_db_s/LOG"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_db_o1",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#transform.cwl/fastqc_db_o1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_db_o1/INPUT",
                            "source": "#transform.cwl/fastqc_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_o1/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_db_o1/LOG"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_db_o2",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#transform.cwl/fastqc_db_o2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_db_o2/INPUT",
                            "source": "#transform.cwl/fastqc_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_o2/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_db_o2/LOG"
                        },
                        {
                            "id": "#transform.cwl/fastqc_db_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_fastqc_db1_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db1_sqlite/source_sqlite",
                            "source": "#transform.cwl/fastqc_db1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db1_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db1_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db1_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_fastqc_db2_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db2_sqlite/source_sqlite",
                            "source": "#transform.cwl/fastqc_db2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db2_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db2_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db2_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_fastqc_db_s_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_s_sqlite/source_sqlite",
                            "source": "#transform.cwl/fastqc_db_s/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_s_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_s_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_s_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_fastqc_db_o1_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o1_sqlite/source_sqlite",
                            "source": "#transform.cwl/fastqc_db_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o1_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o1_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o1_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_fastqc_db_o2_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o2_sqlite/source_sqlite",
                            "source": "#transform.cwl/fastqc_db_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o2_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o2_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_fastqc_db_o2_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_pe_basicstats_json",
                    "run": "#fastqc_basicstatistics_json.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_pe_basicstats_json/sqlite_path",
                            "source": "#transform.cwl/merge_fastqc_db1_sqlite/destination_sqlite"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_pe_basicstats_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_se_basicstats_json",
                    "run": "#fastqc_basicstatistics_json.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_se_basicstats_json/sqlite_path",
                            "source": "#transform.cwl/merge_fastqc_db_s_sqlite/destination_sqlite"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_se_basicstats_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_o1_basicstats_json",
                    "run": "#fastqc_basicstatistics_json.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_o1_basicstats_json/sqlite_path",
                            "source": "#transform.cwl/merge_fastqc_db_o1_sqlite/destination_sqlite"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_o1_basicstats_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/fastqc_o2_basicstats_json",
                    "run": "#fastqc_basicstatistics_json.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/fastqc_o2_basicstats_json/sqlite_path",
                            "source": "#transform.cwl/merge_fastqc_db_o2_sqlite/destination_sqlite"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/fastqc_o2_basicstats_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/decider_bwa_pe",
                    "run": "#decider_bwa_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/decider_bwa_pe/fastq_path",
                            "source": "#transform.cwl/sort_scattered_fastq1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/decider_bwa_pe/readgroup_path",
                            "source": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/decider_bwa_pe/output_readgroup_paths"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/decider_bwa_se",
                    "run": "#decider_bwa_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/decider_bwa_se/fastq_path",
                            "source": "#transform.cwl/sort_scattered_fastq_s/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/decider_bwa_se/readgroup_path",
                            "source": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/decider_bwa_se/output_readgroup_paths"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/decider_bwa_o1",
                    "run": "#decider_bwa_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/decider_bwa_o1/fastq_path",
                            "source": "#transform.cwl/sort_scattered_fastq_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/decider_bwa_o1/readgroup_path",
                            "source": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/decider_bwa_o1/output_readgroup_paths"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/decider_bwa_o2",
                    "run": "#decider_bwa_expression.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/decider_bwa_o2/fastq_path",
                            "source": "#transform.cwl/sort_scattered_fastq_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/decider_bwa_o2/readgroup_path",
                            "source": "#transform.cwl/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/decider_bwa_o2/output_readgroup_paths"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bwa_pe",
                    "run": "#bwa_pe.cwl",
                    "scatter": [
                        "#transform.cwl/bwa_pe/fastq1",
                        "#transform.cwl/bwa_pe/fastq2",
                        "#transform.cwl/bwa_pe/readgroup_json_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#transform.cwl/bwa_pe/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/bwa_pe/fastq1",
                            "source": "#transform.cwl/sort_scattered_fastq1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_pe/fastq2",
                            "source": "#transform.cwl/sort_scattered_fastq2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_pe/readgroup_json_path",
                            "source": "#transform.cwl/decider_bwa_pe/output_readgroup_paths"
                        },
                        {
                            "id": "#transform.cwl/bwa_pe/fastqc_json_path",
                            "source": "#transform.cwl/fastqc_pe_basicstats_json/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_pe/thread_count",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bwa_pe/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bwa_se",
                    "run": "#bwa_se.cwl",
                    "scatter": [
                        "#transform.cwl/bwa_se/fastq",
                        "#transform.cwl/bwa_se/readgroup_json_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#transform.cwl/bwa_se/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/bwa_se/fastq",
                            "source": "#transform.cwl/sort_scattered_fastq_s/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_se/readgroup_json_path",
                            "source": "#transform.cwl/decider_bwa_se/output_readgroup_paths"
                        },
                        {
                            "id": "#transform.cwl/bwa_se/fastqc_json_path",
                            "source": "#transform.cwl/fastqc_se_basicstats_json/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_se/thread_count",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bwa_se/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bwa_o1",
                    "run": "#bwa_se.cwl",
                    "scatter": [
                        "#transform.cwl/bwa_o1/fastq",
                        "#transform.cwl/bwa_o1/readgroup_json_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#transform.cwl/bwa_o1/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/bwa_o1/fastq",
                            "source": "#transform.cwl/sort_scattered_fastq_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_o1/readgroup_json_path",
                            "source": "#transform.cwl/decider_bwa_o1/output_readgroup_paths"
                        },
                        {
                            "id": "#transform.cwl/bwa_o1/fastqc_json_path",
                            "source": "#transform.cwl/fastqc_o1_basicstats_json/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_o1/thread_count",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bwa_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bwa_o2",
                    "run": "#bwa_se.cwl",
                    "scatter": [
                        "#transform.cwl/bwa_o2/fastq",
                        "#transform.cwl/bwa_o2/readgroup_json_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#transform.cwl/bwa_o2/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/bwa_o2/fastq",
                            "source": "#transform.cwl/sort_scattered_fastq_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_o2/readgroup_json_path",
                            "source": "#transform.cwl/decider_bwa_o2/output_readgroup_paths"
                        },
                        {
                            "id": "#transform.cwl/bwa_o2/fastqc_json_path",
                            "source": "#transform.cwl/fastqc_o2_basicstats_json/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/bwa_o2/thread_count",
                            "source": "#transform.cwl/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bwa_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_sortsam_pe",
                    "run": "#picard_sortsam.cwl",
                    "scatter": "#transform.cwl/picard_sortsam_pe/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_sortsam_pe/INPUT",
                            "source": "#transform.cwl/bwa_pe/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_sortsam_pe/OUTPUT",
                            "valueFrom": "$(inputs.INPUT.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_sortsam_pe/SORTED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_sortsam_se",
                    "run": "#picard_sortsam.cwl",
                    "scatter": "#transform.cwl/picard_sortsam_se/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_sortsam_se/INPUT",
                            "source": "#transform.cwl/bwa_se/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_sortsam_se/OUTPUT",
                            "valueFrom": "$(inputs.INPUT.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_sortsam_se/SORTED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_sortsam_o1",
                    "run": "#picard_sortsam.cwl",
                    "scatter": "#transform.cwl/picard_sortsam_o1/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_sortsam_o1/INPUT",
                            "source": "#transform.cwl/bwa_o1/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_sortsam_o1/OUTPUT",
                            "valueFrom": "$(inputs.INPUT.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_sortsam_o1/SORTED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_sortsam_o2",
                    "run": "#picard_sortsam.cwl",
                    "scatter": "#transform.cwl/picard_sortsam_o2/INPUT",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_sortsam_o2/INPUT",
                            "source": "#transform.cwl/bwa_o2/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_sortsam_o2/OUTPUT",
                            "valueFrom": "$(inputs.INPUT.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_sortsam_o2/SORTED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/metrics_pe",
                    "run": "#metrics.cwl",
                    "scatter": "#transform.cwl/metrics_pe/bam",
                    "in": [
                        {
                            "id": "#transform.cwl/metrics_pe/bam",
                            "source": "#transform.cwl/picard_sortsam_pe/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/db_snp_vcf",
                            "source": "#transform.cwl/db_snp_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/input_state",
                            "valueFrom": "sorted_readgroup"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/parent_bam",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/thread_count",
                            "source": "#transform.cwl/thread_count"
                        },
                        {
                            "id": "#transform.cwl/metrics_pe/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/metrics_pe/merge_sqlite_destination_sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_metrics_pe",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_metrics_pe/source_sqlite",
                            "source": "#transform.cwl/metrics_pe/merge_sqlite_destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_metrics_pe/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_metrics_pe/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_metrics_pe/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/metrics_se",
                    "run": "#metrics.cwl",
                    "scatter": "#transform.cwl/metrics_se/bam",
                    "in": [
                        {
                            "id": "#transform.cwl/metrics_se/bam",
                            "source": "#transform.cwl/picard_sortsam_se/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/db_snp_vcf",
                            "source": "#transform.cwl/db_snp_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/input_state",
                            "valueFrom": "sorted_readgroup"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/parent_bam",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/thread_count",
                            "source": "#transform.cwl/thread_count"
                        },
                        {
                            "id": "#transform.cwl/metrics_se/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/metrics_se/merge_sqlite_destination_sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_metrics_se",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_metrics_se/source_sqlite",
                            "source": "#transform.cwl/metrics_se/merge_sqlite_destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_metrics_se/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_metrics_se/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_metrics_se/log"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_mergesamfiles_pe",
                    "run": "#picard_mergesamfiles.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_pe/INPUT",
                            "source": "#transform.cwl/picard_sortsam_pe/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_pe/OUTPUT",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_pe/MERGED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_mergesamfiles_se",
                    "run": "#picard_mergesamfiles.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_se/INPUT",
                            "source": "#transform.cwl/picard_sortsam_se/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_se/OUTPUT",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_se/MERGED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_mergesamfiles_o1",
                    "run": "#picard_mergesamfiles.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o1/INPUT",
                            "source": "#transform.cwl/picard_sortsam_o1/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o1/OUTPUT",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o1/MERGED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_mergesamfiles_o2",
                    "run": "#picard_mergesamfiles.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o2/INPUT",
                            "source": "#transform.cwl/picard_sortsam_o2/SORTED_OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o2/OUTPUT",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles_o2/MERGED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_mergesamfiles",
                    "run": "#picard_mergesamfiles.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles/INPUT",
                            "source": [
                                "#transform.cwl/picard_mergesamfiles_pe/MERGED_OUTPUT",
                                "#transform.cwl/picard_mergesamfiles_se/MERGED_OUTPUT",
                                "#transform.cwl/picard_mergesamfiles_o1/MERGED_OUTPUT",
                                "#transform.cwl/picard_mergesamfiles_o2/MERGED_OUTPUT"
                            ]
                        },
                        {
                            "id": "#transform.cwl/picard_mergesamfiles/OUTPUT",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename.slice(0,-4) + \"_gdc_realn.bam\")"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_mergesamfiles/MERGED_OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/bam_reheader",
                    "run": "#bam_reheader.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/bam_reheader/bam_path",
                            "source": "#transform.cwl/picard_mergesamfiles/MERGED_OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/bam_reheader/output_bam"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_markduplicates",
                    "run": "#picard_markduplicates.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_markduplicates/INPUT",
                            "source": "#transform.cwl/bam_reheader/output_bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_markduplicates/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_markduplicates/METRICS"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_markduplicates_to_sqlite",
                    "run": "#picard_markduplicates_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_markduplicates_to_sqlite/bam",
                            "source": "#transform.cwl/picard_markduplicates/OUTPUT",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#transform.cwl/picard_markduplicates_to_sqlite/input_state",
                            "valueFrom": "markduplicates_readgroups"
                        },
                        {
                            "id": "#transform.cwl/picard_markduplicates_to_sqlite/metric_path",
                            "source": "#transform.cwl/picard_markduplicates/METRICS"
                        },
                        {
                            "id": "#transform.cwl/picard_markduplicates_to_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_markduplicates_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_validatesamfile_markduplicates",
                    "run": "#picard_validatesamfile.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markduplicates/INPUT",
                            "source": "#transform.cwl/picard_markduplicates/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markduplicates/VALIDATION_STRINGENCY",
                            "valueFrom": "STRICT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markduplicates/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite",
                    "run": "#picard_validatesamfile_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/bam",
                            "source": "#transform.cwl/bam_path",
                            "valueFrom": "$(self.basename)"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/input_state",
                            "valueFrom": "markduplicates_readgroups"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/metric_path",
                            "source": "#transform.cwl/picard_validatesamfile_markduplicates/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/metrics_markduplicates",
                    "run": "#mixed_library_metrics.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/metrics_markduplicates/bam",
                            "source": "#transform.cwl/picard_markduplicates/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/metrics_markduplicates/db_snp_vcf",
                            "source": "#transform.cwl/db_snp_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_markduplicates/fasta",
                            "source": "#transform.cwl/reference_fasta_path"
                        },
                        {
                            "id": "#transform.cwl/metrics_markduplicates/input_state",
                            "valueFrom": "markduplicates_readgroups"
                        },
                        {
                            "id": "#transform.cwl/metrics_markduplicates/thread_count",
                            "source": "#transform.cwl/thread_count"
                        },
                        {
                            "id": "#transform.cwl/metrics_markduplicates/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/metrics_markduplicates/merge_sqlite_destination_sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/integrity",
                    "run": "#integrity.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/integrity/bai_path",
                            "source": "#transform.cwl/picard_markduplicates/OUTPUT",
                            "valueFrom": "$(self.secondaryFiles[0])"
                        },
                        {
                            "id": "#transform.cwl/integrity/bam_path",
                            "source": "#transform.cwl/picard_markduplicates/OUTPUT"
                        },
                        {
                            "id": "#transform.cwl/integrity/input_state",
                            "valueFrom": "markduplicates_readgroups"
                        },
                        {
                            "id": "#transform.cwl/integrity/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/integrity/merge_sqlite_destination_sqlite"
                        }
                    ]
                },
                {
                    "id": "#transform.cwl/merge_all_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#transform.cwl/merge_all_sqlite/source_sqlite",
                            "source": [
                                "#transform.cwl/picard_validatesamfile_original_to_sqlite/sqlite",
                                "#transform.cwl/picard_validatesamfile_markdupl_to_sqlite/sqlite",
                                "#transform.cwl/merge_readgroup_json_db/destination_sqlite",
                                "#transform.cwl/merge_fastqc_db1_sqlite/destination_sqlite",
                                "#transform.cwl/merge_fastqc_db2_sqlite/destination_sqlite",
                                "#transform.cwl/merge_fastqc_db_s_sqlite/destination_sqlite",
                                "#transform.cwl/merge_fastqc_db_o1_sqlite/destination_sqlite",
                                "#transform.cwl/merge_fastqc_db_o2_sqlite/destination_sqlite",
                                "#transform.cwl/merge_metrics_pe/destination_sqlite",
                                "#transform.cwl/merge_metrics_se/destination_sqlite",
                                "#transform.cwl/metrics_markduplicates/merge_sqlite_destination_sqlite",
                                "#transform.cwl/picard_markduplicates_to_sqlite/sqlite",
                                "#transform.cwl/integrity/merge_sqlite_destination_sqlite"
                            ]
                        },
                        {
                            "id": "#transform.cwl/merge_all_sqlite/uuid",
                            "source": "#transform.cwl/uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#transform.cwl/merge_all_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#transform.cwl/merge_all_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#transform.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
